# History

## 1. From Commercial Closed Source To Community Open Source

OpenMLDB originated as an internal commercial product of [4Paradigm](https://www.4paradigm.com), an industry-leading artificial intelligence platform and service provider. The commercial AI platform provided by 4Paradigm covers the entire process of machine learning end-to-end application development and implementation, including data governance, feature engineering, model training and inference, and model management. Its products have been deployed and applied on a large scale in hundreds of enterprise-level scenarios.

In 2021, the development team abstracted, enhanced, and added many community-friendly features to the core modules of data governance and feature engineering in the commercial products, and finally made it publicly available as an opensource project OpenMLDB. OpenMLDB is born out of a commercial product that has been tested for up to five years, and has a lot of experience and unique understanding in this field. Today, OpenMLDB develops based on the open source and open community, and hopes to help more enterprises complete the transformation of artificial intelligence with low cost and high quality.

## 2. Milestones

### 2017.2 - 2021.5: Internal  MLDB

- 2017.2: The first code commit
- 2017.9: The first financial industry customer, China Guangfa Bank
- 2019.8: The first retail industry user, Yum China
- 2020.12: The cumulative number of real-world applications exceeds 100

### 2021.6 - Today: Open Source OpenMLDB

- 2021.6: Machine learning database OpenMLDB officially announced open source, providing enterprise-grade full-stack FeatureOps solution
- 2021.7: v0.2.0 released, supporting RestAPI access, code style and comments improved
- 2021.8: OpenMLDB-based optimization innovation papers are published at VLDB 2021, the top international academic conference on databases
- 2021.8: Recognized by Gitee and awarded the title of GVP (Gitee Most Valuable Project)
- 2021.9: The first community enterprise user, [Akulaku](https://www.akulaku.com/)
- 2021.9: Won the "Open Source Community and Open Source Project" award from the Academy of Information and Communications Technology
- 2021.11: v0.3.0 released, supporting standalone deployment mode for rapid deployment
- 2021.12: OpenMLDB Contributor Program launched
- 2021.12: Host the first Feature Store Meetup in China
- 2022.1: v0.4.0 released, enhancing the SQL-centric development experience, introducing the new online monitoring module
- 2022.1: OpenMLDB first community meeting
- 2022.5: v0.5.0 released, supporting long window and persistent storage engine, registering udf from external dynamic library

## 3. Roadmap

The future development of OpenMLDB will firmly follow the path of community-based open source and to benefit more enterprises and developers. In the future, in terms of technology, we will pay more attention to technologies that can effectively reduce the threshold and cost of use, such as cloud-native technology. In terms of community building, OpenMLDB will integrate into the open-source ecosystem, and expand cooperation between industry and academia. Finally, we hope that more developers and users can participate in our community and jointly promote the rapid growth of the OpenMLDB community.
